/*
* Delete Rename Mask,
* Informs server of the mask to delete, if it manages it ok then we remove locally from the html
* TODO internationalize error messages
*/
function deleteRenameMask()
{
    var selectMask = document.getElementById("filenamemasks");
    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.delete_rename_mask', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(selectMask.options[document.getElementById("filenamemasks").selectedIndex].text);
    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                var index = selectMask.selectedIndex;
                selectMask.remove(index);
            }
            else
            {
               alert(xhr.responseText.substring(6));
            }
        }
    };
}

/**
* Add new Rename Mask, make request to server to actually add new mask
* TODO add in right place instead of end.
*/
function addRenameMask()
{
    var selectMask = document.getElementById("filenamemasks");

    var maskName = document.getElementById("add_filename_mask_name").value;
    var maskMask = document.getElementById("add_filename_mask_mask").value;

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.add_rename_mask', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(maskName+":"+maskMask);

    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                document.getElementById("add_filename_mask_name").value = "";
                document.getElementById("add_filename_mask_mask").value = "";
                $('#addmodal').modal('hide')

                var newmask = document.createElement("option");
                newmask.text  = maskName;
                newmask.value = maskMask;
                selectMask.add(newmask);
            }
            else
            {
                addAlertToModal(document.getElementById("addmodalAlerts"),xhr.responseText.substring(6));
            }
        }
    };
}

/**
* Modify Rename Mask, make request to server to actually save changes to the renamemask
*/
function editRenameMask()
{
    var selectMask = document.getElementById("filenamemasks");
    var maskName = document.getElementById("edit_filename_mask_name").value;
    var maskMask = document.getElementById("edit_filename_mask_mask").value;
    var index = selectMask.selectedIndex;

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.edit_rename_mask', true);
    xhr.setRequestHeader("Content-type", "text/plain");

    var origMaskName = selectMask.options[selectMask.selectedIndex].text;

    xhr.send(origMaskName+":"+maskName+":"+maskMask);

    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                document.getElementById("edit_filename_mask_name").value = "";
                document.getElementById("edit_filename_mask_mask").value = "";
                $('#editmodal').modal('hide')

                selectMask[index].text = maskName;
                selectMask[index].value = maskMask;
            }
            else
            {
                addAlertToModal(document.getElementById("editmodalAlerts"),xhr.responseText.substring(6));
            }
        }
    };
}


/**
* Clone new Rename Mask, make request to server to actually add new cloned mask
* TODO add in right place instead of end.
*/
function cloneRenameMask()
{
    var selectMask = document.getElementById("filenamemasks");

    var maskName = document.getElementById("clone_filename_mask_name").value;
    var maskMask = document.getElementById("clone_filename_mask_mask").value;

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.add_rename_mask', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(maskName+":"+maskMask);

    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                document.getElementById("clone_filename_mask_name").value = "";
                document.getElementById("clone_filename_mask_mask").value = "";
                $('#clonemodal').modal('hide')

                var newmask = document.createElement("option");
                newmask.text  = maskName;
                newmask.value = maskMask;
                selectMask.add(newmask);
            }
            else
            {
                addAlertToModal(document.getElementById("clonemodalAlerts"),xhr.responseText.substring(6));
            }
        }
    };
}

/** Add folder separator to the mask
*/
function addSimpleToMask(modalId,select, maskId)
{
    var mask          = document.getElementById(maskId);
    var selectedValue = document.getElementById(select).value;
    var scriptvar     = selectedValue.substring(0, selectedValue.indexOf(":"));

    if(mask.value.length==0)
    {
        mask.value = mask.value += scriptvar;
    }
    else
    {
        mask.value = mask.value +=" + " + scriptvar;
    }

    //Update Examples
    updateExampleMask(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}

function addFirstValueToMask(modalId,select, maskId)
{
    var mask = document.getElementById(maskId);
    var selectedValue = document.getElementById(select).value;
    var scriptvar     = selectedValue.substring(0, selectedValue.indexOf(":"));

    if(mask.value.length==0)
    {
        mask.value = mask.value += scriptvar + "_index[0]";
    }
    else
    {
        mask.value = mask.value +=" + " + scriptvar + "_index[0]";;
    }

    //Update Examples
    updateExampleMask(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}

function addSecondValueToMask(modalId,select, maskId)
{
    var mask = document.getElementById(maskId);
    var selectedValue = document.getElementById(select).value;
    var scriptvar     = selectedValue.substring(0, selectedValue.indexOf(":"));

    if(mask.value.length==0)
    {
        mask.value = mask.value += scriptvar + "_index[1]";
    }
    else
    {
        mask.value = mask.value +=" + " + scriptvar + "_index[1]";;
    }

    //Update Examples
    updateExampleMask(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}

function enableDisableScriptFieldButtons(modalId,select,buttonIdFirstValue, buttonIdSecondValue)
{
    var selectedValue = document.getElementById(select).value;
    var isMulti       = selectedValue.substring(selectedValue.indexOf(":")+1);
    if(isMulti==='true')
    {
        document.getElementById(buttonIdFirstValue).disabled=false;
        document.getElementById(buttonIdSecondValue).disabled=false;
    }
    else
    {
        document.getElementById(buttonIdFirstValue).disabled=true;
        document.getElementById(buttonIdSecondValue).disabled=true;
    }
}


/** Add folder separator to the mask
*/
function addFolderSeparatorToMask(modalId,maskId)
{
    var mask = document.getElementById(maskId);
    if(mask.value.length==0)
    {
        mask.value = mask.value +="'/'";
    }
    else
    {
        mask.value = mask.value +=" + " + "'/'";
    }

    //Update Examples
    updateExampleMask(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}

function addFunctionToMask(modalId,select, maskId)
{
    var mask = document.getElementById(maskId);
    var selectedValue = document.getElementById(select).value;
    var functionPrototype = selectedValue;

    if(mask.value.length==0)
    {
        mask.value = mask.value += functionPrototype;
    }
    else
    {
        mask.value = mask.value +=" + " + functionPrototype;
    }

    //Update Examples
    updateExampleMask(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}

/*
* Update Examples when when editing or adding a filename mask
*/
function updateExampleMask(maskValue, exampleField, alertsField)
{
  var xhr = new XMLHttpRequest();
  xhr.open('POST', '/preferences.example_mask', true);
  xhr.send(maskValue);
        xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText.startsWith('ok'))
            {
               exampleField.innerHTML=xhr.responseText.substring(3);
               removeAllAlerts(alertsField);
            }
            else
            {
               var errorMsgWithoutErrorCode=xhr.responseText.substring(6);
               var errorMsg=errorMsgWithoutErrorCode.substring(0, errorMsgWithoutErrorCode.indexOf(':'));
               var exampleMsg=errorMsgWithoutErrorCode.substring(errorMsgWithoutErrorCode.indexOf(':') + 1);
               exampleField.innerHTML=exampleMsg;
               addAlertToModal(alertsField, errorMsg);
            }
        }
     };
}

/*
* Populate Edit Mask Dialog with value currently selected in combo
*/
$('#editmodal').on('show.bs.modal', function (e) {
  var opt = document.getElementById("filenamemasks").options[document.getElementById("filenamemasks").selectedIndex];
  document.getElementById("edit_filename_mask_name").value = opt.text
  document.getElementById("edit_filename_mask_mask").value = opt.value.trim();
  removeAllAlerts(document.getElementById("editmodalAlerts"));
  updateExampleMask(document.getElementById("edit_filename_mask_mask").value, document.getElementById("editmodalexample"), document.getElementById("editmodalAlerts"));
});

/*
* Populate Clone Filename Mask Dialog with value currently selected in combo
*/
$('#clonemodal').on('show.bs.modal', function (e) {
  var opt = document.getElementById("filenamemasks").options[document.getElementById("filenamemasks").selectedIndex];
  document.getElementById("clone_filename_mask_name").value = opt.text + ' Clone'
  document.getElementById("clone_filename_mask_mask").value = opt.value.trim();
  removeAllAlerts(document.getElementById("clonemodalAlerts"));
  updateExampleMask(document.getElementById("clone_filename_mask_mask").value, document.getElementById("clonemodalexample"), document.getElementById("clonemodalAlerts"));
});

/** Update example mask whenever modifications made to edit filename mask */
$('#edit_filename_mask_mask').focusout(function(){
    updateExampleMask(document.getElementById("edit_filename_mask_mask").value, document.getElementById("editmodalexample"), document.getElementById("editmodalAlerts"));
});

/** Update example mask whenever modifications made to clone filename mask */
$('#clone_filename_mask_mask').focusout(function(){
    updateExampleMask(document.getElementById("clone_filename_mask_mask").value, document.getElementById("clonemodalexample"), document.getElementById("clonemodalAlerts"));
});

/** Update example mask whenever modifications made to add filename mask */
$('#add_filename_mask_mask').focusout(function(){
    updateExampleMask(document.getElementById("add_filename_mask_mask").value, document.getElementById("addmodalexample"), document.getElementById("addmodalAlerts"));
});

/*
* Clear any alert messages from previous dialog
*/
$('#addmodal').on('show.bs.modal', function (e) {
  removeAllAlerts(document.getElementById("addmodalAlerts"));
});

/**
 * Delete selected Javascript Function, send request to server to do actual delete and then remove from list
 * if successful
 */
function deleteFunction()
{
    var functions = document.getElementById("javascriptFunctions");
    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.delete_function', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(functions.options[functions.selectedIndex].text);
    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                var index = functions.selectedIndex;
                functions.remove(index);
            }
            else
            {
                alert(xhr.responseText.substring(6));
            }
        }
    };
}

/**
* Add new Javascript Function, after user has created function in UI make request to server to actually add it.
* TODO add in right place instead of end.
*/
function addFunction()
{
    var functions           = document.getElementById("javascriptFunctions");
    var editMaskFunctions   = document.getElementById("editMaskJavascriptList");
    var addMaskFunctions    = document.getElementById("addMaskJavascriptList");

    var javascriptFunction  = document.getElementById("add_function").value;

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.add_function', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(javascriptFunction);
    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText.startsWith('ok:'))
            {
                document.getElementById("add_function").value = "";
                $('#addModalFunction').modal('hide');

                var newFunction = document.createElement("option");
                newFunction.text  = xhr.responseText.substring(3);
                newFunction.value = javascriptFunction;
                functions.add(newFunction);
                sortAlphabetically("#javascriptFunctions");

                var newFunctionName = document.createElement("option");
                newFunctionName.text  = xhr.responseText.substring(3);
                newFunctionName.value = xhr.responseText.substring(3);
                addMaskFunctions.add(newFunctionName);
                sortAlphabetically("#addMaskJavascriptList");

                var newFunctionNameEdit = document.createElement("option");
                newFunctionNameEdit.text  = xhr.responseText.substring(3);
                newFunctionNameEdit.value = xhr.responseText.substring(3);
                editMaskFunctions.add(newFunctionNameEdit);
                sortAlphabetically("#editMaskJavascriptList");

            }
            else
            {
                addAlertToModal(document.getElementById("addModalFunctionAlerts"),xhr.responseText.substring(6));
            }
        }
    };
}

/**
* Sort contents of select alphabetically
*/
function sortAlphabetically(selectName)
{
        var functionsToSort = $(selectName + ' ' + 'option');
        functionsToSort.sort(function(a,b){
           var textA = a.text.toUpperCase();
           var textB = b.text.toUpperCase();
           return (textA < textB) ? -1 : (textA > textB) ? 1 : 0;
        });
        $(selectName).html(functionsToSort);
}
/**
* Add error msg to modal (remove existing messages first
*/
function addAlertToModal(alerts, msg)
{
    removeAllAlerts(alerts);
    var alert = document.createElement("div");
    var msg   = document.createTextNode(msg);
    alert.className = "alert alert-danger";
    //alert.role = "alert";
    alert.appendChild(msg);
    alerts.appendChild(alert);
}

function removeAllAlerts(alerts)
{
    while (alerts.hasChildNodes()) {
      alerts.removeChild(alerts.lastChild);
    }
}

/**
* Saved edited Javascript Function, after user has edited in UI send request to server
* TODO Reorder
*/
function editFunction()
{
   var functions           = document.getElementById("javascriptFunctions");
   var editMaskFunctions   = document.getElementById("editMaskJavascriptList");
   var addMaskFunctions    = document.getElementById("addMaskJavascriptList");
   var javascriptFunction  = document.getElementById("edit_function").value;
   var origFunctionName    = functions.options[functions.selectedIndex].text;
   var index = functions.selectedIndex;

   var xhr = new XMLHttpRequest();
   xhr.open('POST', '/preferences.edit_function', true);
   xhr.setRequestHeader("Content-type", "text/plain");
   xhr.send(origFunctionName+":"+javascriptFunction);
   xhr.onreadystatechange = function() {
       if (this.readyState == 4 && this.status == 200)
       {
           if(xhr.responseText.startsWith('ok:'))
           {
               document.getElementById("edit_function").value = "";
               $('#editModalFunction').modal('hide')

               functions[index].text  = xhr.responseText.substring(3)
               functions[index].value = javascriptFunction;
               sortAlphabetically("#javascriptFunctions");

               editMaskFunctions[index].text  = xhr.responseText.substring(3)
               editMaskFunctions[index].value = xhr.responseText.substring(3)
               sortAlphabetically("#editMaskJavascriptList");

               addMaskFunctions[index].text   = xhr.responseText.substring(3)
               addMaskFunctions[index].value  = xhr.responseText.substring(3)
               sortAlphabetically("#addMaskJavascriptList");
           }
           else
           {
               addAlertToModal(document.getElementById("editModalFunctionAlerts"),xhr.responseText.substring(6));
           }
       }
   };
}

/*
* Populate Edit Javascript function with value currently selected in combo
*/
$('#editModalFunction').on('show.bs.modal', function (e) {
  var opt = document.getElementById("javascriptFunctions").options[document.getElementById("javascriptFunctions").selectedIndex];
  document.getElementById("edit_function").value = opt.value;
  removeAllAlerts(document.getElementById("editModalFunctionAlerts"));
});

/*
* Clear any alert messages from previous dialog
*/
$('#addModalFunction').on('show.bs.modal', function (e) {
  removeAllAlerts(document.getElementById("addModalFunctionAlerts"));
});

/*
* Populate Rename Profile Dialog with profile currently selected in combo
*/
$('#renameprofilemodal').on('show.bs.modal', function (e) {
  var opt = document.getElementById("profiles").options[document.getElementById("profiles").selectedIndex];
  document.getElementById("rename_profile").value = opt.text;

  removeAllAlerts(document.getElementById("renameprofilemodalAlerts"));
});

/*
* Check Acoustid User Key
*/
function checkAcoustIdUserKey()
{
    var acoustidUserKey = document.getElementById("acoustidUserKey");

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.check_acoustid_user_key', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(acoustidUserKey.value);
    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            var code = xhr.responseText.substring(0,2);
            var msg  = xhr.responseText.substring(2);

            if(code.startsWith("1:"))
            {
                document.getElementById("acoustid_user_key_error").innerHTML = msg;
                document.getElementById("acoustid_user_key_error").style.color="red";
            }
            else
            {
                document.getElementById("acoustid_user_key_error").innerHTML = msg;
                document.getElementById("acoustid_user_key_error").style.color="green";
            }

        }
    };
}

/*
* Populate Example Song Data dialog with values from the selected property file
*/
$('#editModalExample').on('show.bs.modal', function (e) {
  var opt = document.getElementById("exampleSongDataList").options[document.getElementById("exampleSongDataList").selectedIndex];
  document.getElementById("edit_example").innerHTML = opt.value;
  removeAllAlerts(document.getElementById("editModalFunctionAlerts"));
});

/**
* Save changes to Example Song Data
*/
function saveExampleSongData()
{
   var opt = document.getElementById("exampleSongDataList").options[document.getElementById("exampleSongDataList").selectedIndex];
   var data = opt.text+">>>>";
   var elements = document.getElementsByClassName("songdata");
   for (let i = 0; i < elements.length; i++)
   {
        songdata = elements[i];
        data+=(songdata.id+"::::"+songdata.value+";;;;");
   }

   var xhr = new XMLHttpRequest();
   xhr.open('POST', '/preferences.example_song_data', true);
   xhr.setRequestHeader("Content-type", "text/plain");
   xhr.send(data);
   xhr.onreadystatechange = function() {
       if (this.readyState == 4 && this.status == 200)
       {
           if(xhr.responseText.startsWith('ok:'))
           {
                var exampleSongDataList = document.getElementById("exampleSongDataList");
                exampleSongDataList.innerHTML=xhr.responseText.substring(3);
           }
           else
           {
               addAlertToModal(document.getElementById("editModalFunctionAlerts"),xhr.responseText.substring(6));
           }
       }
   };
}


/*
* On display Populate Edit Classical People List Dialog with current contents of file
*/
$('#ClassicalPeopleModal').on('show.bs.modal', function (e)
{
    updateWithFileContents("ClassicalPeopleContents", "classical_people.txt")
});

$('#ClassicalComposerModal').on('show.bs.modal', function (e)
{
    updateWithFileContents("ClassicalComposerContents", "classical_composers.txt")
});

$('#ClassicalConductorModal').on('show.bs.modal', function (e)
{
    updateWithFileContents("ClassicalConductorContents", "classical_conductors.txt")
});

$('#NotClassicalReleaseModal').on('show.bs.modal', function (e)
{
    updateWithFileContents("NotClassicalReleaseContents", "not_classical_release.txt")
});

$('#NotClassicalReleaseGroupModal').on('show.bs.modal', function (e)
{
    updateWithFileContents("NotClassicalReleaseGroupContents", "not_classical_release_group.txt")
});

$('#ComposersUseInitialsModal').on('show.bs.modal', function (e)
{
    updateWithFileContents("ComposersUseInitialsContents", "album_composers_use_initials.txt")
});

$('#GenresModal').on('show.bs.modal', function (e)
{
    updateWithFileContents("GenresContents", "genrelist.txt")
});

$('#songkonguserlogModal').on('show.bs.modal', function (e)
{
    getLogFileContents("songkonguserlogContents", "songkong_user0-0.log")
});

$('#songkongdebuglogModal').on('show.bs.modal', function (e)
{
    getLogFileContents("songkongdebuglogContents", "songkong_debug0-0.log")
});

function updateWithFileContents(id, filename)
{
   var xhr = new XMLHttpRequest();
   xhr.open('POST', '/preferences.get_file_contents', true);
   xhr.setRequestHeader("Content-type", "text/plain");
   xhr.send(filename);
   xhr.onreadystatechange = function() {
       if (this.readyState == 4 && this.status == 200)
       {
           document.getElementById(id).value = xhr.responseText;
       }
   };
}

function saveFileContents(modalId, filename)
{
   var fileData = document.getElementById(modalId).value;
   var xhr = new XMLHttpRequest();
   xhr.open('POST', '/preferences.save_file_contents', true);
   xhr.setRequestHeader("Content-type", "text/plain");
   xhr.send(filename + ":" + fileData);
}

function getLogFileContents(id, filename)
{
   var xhr = new XMLHttpRequest();
   xhr.open('POST', '/preferences.get_logfile_contents', true);
   xhr.setRequestHeader("Content-type", "text/plain");
   xhr.send(filename);
   xhr.onreadystatechange = function() {
       if (this.readyState == 4 && this.status == 200)
       {
           document.getElementById(id).value = xhr.responseText;
       }
   };
}

/*
* Delete Rename Mask,
* Informs server of the mask to delete, if it manages it ok then we remove locally from the html
* TODO internationalize error messages
*/
function deleteScript()
{
    var selectMask = document.getElementById("scripts");
    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.delete_script', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(selectMask.options[document.getElementById("scripts").selectedIndex].text);
    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                var index = selectMask.selectedIndex;
                selectMask.remove(index);
            }
            else
            {
               alert(xhr.responseText.substring(6));
            }
        }
    };
}

/**
* Add new Script, make request to server to actually add new mask
* TODO add in right place instead of end.
*/
function addScript()
{
    var selectMask = document.getElementById("scripts");

    var maskName = document.getElementById("add_script_name").value;
    var maskMask = document.getElementById("add_script_mask").value;

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.add_script', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(maskName+":"+maskMask);

    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                document.getElementById("add_script_name").value = "";
                document.getElementById("add_script_mask").value = "";
                $('#addscriptmodal').modal('hide')

                var newmask = document.createElement("option");
                newmask.text  = maskName;
                newmask.value = maskMask;
                selectMask.add(newmask);
            }
            else
            {
                addAlertToModal(document.getElementById("addscriptmodalAlerts"),xhr.responseText.substring(6));
            }
        }
    };
}

/**
* Modify Script, make request to server to actually save changes to the renamemask
*/
function editScript()
{
    var selectMask = document.getElementById("scripts");
    var maskName = document.getElementById("edit_script_name").value;
    var maskMask = document.getElementById("edit_script_mask").value;
    var index = selectMask.selectedIndex;

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.edit_script', true);
    xhr.setRequestHeader("Content-type", "text/plain");

    var origMaskName = selectMask.options[selectMask.selectedIndex].text;

    xhr.send(origMaskName+":"+maskName+":"+maskMask);

    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                document.getElementById("edit_script_name").value = "";
                document.getElementById("edit_script_mask").value = "";
                $('#editscriptmodal').modal('hide')

                selectMask[index].text = maskName;
                selectMask[index].value = maskMask;
            }
            else
            {
                addAlertToModal(document.getElementById("editscriptmodalAlerts"),xhr.responseText.substring(6));
            }
        }
    };
}


/**
* Clone Script, make request to server to actually add new cloned mask
* TODO add in right place instead of end.
*/
function cloneScript()
{
    var selectMask = document.getElementById("scripts");

    var maskName = document.getElementById("clone_script_name").value;
    var maskMask = document.getElementById("clone_script_mask").value;

    var xhr = new XMLHttpRequest();
    xhr.open('POST', '/preferences.add_script', true);
    xhr.setRequestHeader("Content-type", "text/plain");
    xhr.send(maskName+":"+maskMask);

    xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText=='ok')
            {
                document.getElementById("clone_script_name").value = "";
                document.getElementById("clone_script_mask").value = "";
                $('#clonescriptmodal').modal('hide')

                var newmask = document.createElement("option");
                newmask.text  = maskName;
                newmask.value = maskMask;
                selectMask.add(newmask);
            }
            else
            {
                addAlertToModal(document.getElementById("clonescriptmodalAlerts"),xhr.responseText.substring(6));
            }
        }
    };
}

/*
* Populate Edit Script Dialog with value currently selected in combo
*/
$('#editscriptmodal').on('show.bs.modal', function (e) {
  var opt = document.getElementById("scripts").options[document.getElementById("scripts").selectedIndex];
  document.getElementById("edit_script_name").value = opt.text
  document.getElementById("edit_script_mask").value = opt.value.trim();
  removeAllAlerts(document.getElementById("editscriptmodalAlerts"));
  updateExampleScript(document.getElementById("edit_script_mask").value, document.getElementById("editscriptmodalexample"), document.getElementById("editscriptmodalAlerts"));
});

/*
* Populate Clone Script Dialog with value currently selected in combo
*/
$('#clonescriptmodal').on('show.bs.modal', function (e) {
  var opt = document.getElementById("scripts").options[document.getElementById("scripts").selectedIndex];
  document.getElementById("clone_script_name").value = opt.text + ' Clone'
  document.getElementById("clone_script_mask").value = opt.value.trim();
  removeAllAlerts(document.getElementById("clonescriptmodalAlerts"));
  updateExampleScript(document.getElementById("clone_script_mask").value, document.getElementById("clonescriptmodalexample"), document.getElementById("clonescriptmodalAlerts"));
});

/*
* Update Example when editing or adding a script
*/
function updateExampleScript(maskValue, exampleField, alertsField)
{
  var xhr = new XMLHttpRequest();
  xhr.open('POST', '/preferences.example_script', true);
  xhr.send(maskValue);
        xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200)
        {
            if(xhr.responseText.startsWith('ok'))
            {
               exampleField.innerHTML=xhr.responseText.substring(3);
               removeAllAlerts(alertsField);
            }
            else
            {
               var errorMsgWithoutErrorCode=xhr.responseText.substring(6);
               var errorMsg=errorMsgWithoutErrorCode.substring(0, errorMsgWithoutErrorCode.indexOf(':'));
               var exampleMsg=errorMsgWithoutErrorCode.substring(errorMsgWithoutErrorCode.indexOf(':') + 1);
               exampleField.innerHTML=exampleMsg;
               addAlertToModal(alertsField, errorMsg);
            }
        }
     };
}

/** Update script example whenever modifications made to edit script mask */
$('#edit_script_mask').focusout(function(){
    updateExampleScript(document.getElementById("edit_script_mask").value, document.getElementById("editscriptmodalexample"), document.getElementById("editscriptmodalAlerts"));
});

/** Update script example whenever modifications made to clone script mask */
$('#clone_script_mask').focusout(function(){
    updateExampleScript(document.getElementById("clone_script_mask").value, document.getElementById("clonescriptmodalexample"), document.getElementById("clonescriptmodalAlerts"));
});

/** Update script example whenever modifications made to add script mask */
$('#add_script_mask').focusout(function(){
    updateExampleScript(document.getElementById("add_script_mask").value, document.getElementById("addscriptmodalexample"), document.getElementById("addscriptmodalAlerts"));
});

function addFunctionToScript(modalId,select, maskId)
{
    var mask = document.getElementById(maskId);
    var selectedValue = document.getElementById(select).value;
    var functionPrototype = selectedValue;

    if(mask.value.length==0)
    {
        mask.value = mask.value += functionPrototype;
    }
    else
    {
        mask.value = mask.value +=" + " + functionPrototype;
    }

    //Update Examples
    updateExampleScript(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}

/** Add folder separator to the mask
*/
function addSimpleToScript(modalId,select, maskId)
{
    var mask          = document.getElementById(maskId);
    var selectedValue = document.getElementById(select).value;
    var scriptvar     = selectedValue.substring(0, selectedValue.indexOf(":"));

    if(mask.value.length==0)
    {
        mask.value = mask.value += scriptvar;
    }
    else
    {
        mask.value = mask.value +=" + " + scriptvar;
    }

    //Update Examples
    updateExampleScript(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}

function addFirstValueToScript(modalId,select, maskId)
{
    var mask = document.getElementById(maskId);
    var selectedValue = document.getElementById(select).value;
    var scriptvar     = selectedValue.substring(0, selectedValue.indexOf(":"));

    if(mask.value.length==0)
    {
        mask.value = mask.value += scriptvar + "_index[0]";
    }
    else
    {
        mask.value = mask.value +=" + " + scriptvar + "_index[0]";;
    }

    //Update Examples
    updateExampleScript(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}

function addSecondValueToScript(modalId,select, maskId)
{
    var mask = document.getElementById(maskId);
    var selectedValue = document.getElementById(select).value;
    var scriptvar     = selectedValue.substring(0, selectedValue.indexOf(":"));

    if(mask.value.length==0)
    {
        mask.value = mask.value += scriptvar + "_index[1]";
    }
    else
    {
        mask.value = mask.value +=" + " + scriptvar + "_index[1]";;
    }

    //Update Examples
    updateExampleScript(mask.value, document.getElementById(modalId + "example"), document.getElementById(modalId+"Alerts"));
}